<script>
    var requireJS = [];
    //loadJS(requireJS, "js/views/member_profile.js");
</script>


<style>
    input[type="file"] {
        display: none;
    }

    .custom-file-upload {
        border: 1px solid #ccc;
        display: inline-block;
        padding: 6px 12px;
        cursor: pointer;
    }
</style>

<div class="text-center border-dark pre-scrollable" style="overflow: scroll;">
    <canvas class="border-dark" id="imageCanvas" width="500" height="250"></canvas>
</div>

<div class="alert alert-success" id="alert-box"></div>

<div class="row text-center">            
    <div class="col-sm-4 col-md-4 col-xs-4">
        <label class="custom-file-upload">
            <input type="hidden" name="bacsId" id="bacsId" th:value="${bacsId}"/>
            <input type="hidden" name="type" id="type" th:value="${type}"/>
            <input type="file" id="imageLoader" name="imageLoader" accept="image/*"/>
            <i class="fa fa-cloud-upload"></i><span th:text="#{optSelect}"></span>
        </label>
    </div>
    <div class="col-sm-4 col-md-4 col-xs-4">
        <label class="custom-file-upload">    
            <a id="save"><i class="fa fa-save"></i>&nbsp;<span th:text="#{btnSave}"></span></a>
            <!--            <button class="btn btn-info btn-sm" id="save"><i class="fa fa-save"></i>&nbsp;<span th:text="#{btnSave}"></span></button>-->
        </label>
    </div>
    <div class="col-sm-4 col-md-4 col-xs-4">
        <label class="custom-file-upload">
            <!--            <a id="save"><i class="fa fa-save"></i>&nbsp;<span th:text="#{btnSave}"></span></a>-->
            <a data-dismiss="modal"><i class="fa fa-remove"></i>&nbsp;<span th:text="#{btnCerrar}"></span></a>
        </label>
    </div>
</div>



<script>

    $(document).ready(function ($) {

        $('#alert-box').hide();

        var imageLoader = document.getElementById('imageLoader');
        imageLoader.addEventListener('change', handleImage, false);

        var canvas = document.getElementById('imageCanvas');
        var ctx = canvas.getContext('2d');

        function handleImage(e) {
            var reader = new FileReader();
            reader.onload = function (event) {
                var img = new Image();
                img.onload = function () {

                    /*var hRatio = canvas.width / img.width;
                     var vRatio = canvas.height / img.height;
                     var ratio = Math.min(hRatio, vRatio);
                     var centerShift_x = (canvas.width - img.width * ratio) / 2;
                     var centerShift_y = (canvas.height - img.height * ratio) / 2;
                     ctx.clearRect(0, 0, canvas.width, canvas.height);
                     ctx.drawImage(img, 0, 0, img.width, img.height, centerShift_x, centerShift_y, img.width * ratio, img.height * ratio);*/


                    canvas.width = img.width;
                    canvas.height = img.height;
                    ctx.drawImage(img, 0, 0);

                    /*canvas.width = 500;
                     canvas.height = 250;
                     ctx.drawImage(img, 0, 0, 500, 250);*/

                },
                        img.src = event.target.result;
            },
                    reader.readAsDataURL(e.target.files[0]);
        }

        var saveButton = document.getElementById('save');
        saveButton.addEventListener('click', postSave, false);

        function postSave(e) {

            $('#alert-box').hide();

            if (isCanvasBlank(canvas)) {
                $('#alert-box').show();
                $('#alert-box').removeClass('alert-success');
                $('#alert-box').addClass('alert-danger');
                $('#alert-box').html("Seleccione una imagen valida");
                return;
            }

            var bacsId = $('#bacsId').val();
            var type = $('#type').val();
            var dataURL = canvas.toDataURL();
            //var dataURL = ctx.getImageData();

            $.ajax({
                type: "POST",
                url: "/members/profile/media/add/" + type,
                data: {
                    imgBase64: dataURL,
                    bacsId: bacsId
                }
            }).fail(function (jqXHR, textStatus, errorThrown) {

                $('#alert-box').show();
                $('#alert-box').removeClass('alert-success');
                $('#alert-box').addClass('alert-danger');
                $('#alert-box').html(textStatus);

            }).done(function (o) {

                $('#alert-box').show();
                $('#alert-box').removeClass('alert-danger');
                $('#alert-box').addClass('alert-success');
                $('#alert-box').html(o);
            });
        }


        function isCanvasBlank(canvas) {
            const context = canvas.getContext('2d');
            const pixelBuffer = new Uint32Array(context.getImageData(0, 0, canvas.width, canvas.height).data.buffer);
            return !pixelBuffer.some(color => color !== 0);
        }

    });

</script>